program streams;
{ TP 6.0 Version 1.0 mit Timer und HiScore }

uses crt,dos,graph,BGIdriv,BGIFont,drivers;

const dx=24; dy=24; xmax=24; ymax=16;
      ox=16; oy=36; hscfile='Streams.hsc';

type feld   =array[0..xmax,0..ymax] of integer;
     imabuff=array[0..4000] of byte;
     hscliste=array[0..11] of record
                  namen:string; level:integer; score:longint
              end;

{$i c:\tp6\projekte\intu1.inc }

var ibuff:imabuff;
    hsc  :hscliste;
    l,level,x,y,xo,yo,ti,count:integer;
    f,fo          :array[0..succ(xmax),0..succ(ymax)] of integer;
    ima           :array[1..3] of image;
    ok,ende,fertig:boolean;
    p_hilf        :pointer;
    lnamen        :string;
    h,m,s,hd      :word;
    punkte        :longint;


{ Screen- und Musekram ------------------- }

procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

procedure register;
begin
  { Register all the drivers }
  if RegisterBGIdriver(@CGADriverProc) < 0 then
    Abort('CGA');
  if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Abort('EGA/VGA');
  if RegisterBGIdriver(@HercDriverProc) < 0 then
    Abort('Herc');
  if RegisterBGIdriver(@ATTDriverProc) < 0 then
    Abort('AT&T');
  if RegisterBGIdriver(@PC3270DriverProc) < 0 then
    Abort('PC 3270');
  { Register all the fonts }
  if RegisterBGIfont(@GothicFontProc) < 0 then
    Abort('Gothic');
  if RegisterBGIfont(@SansSerifFontProc) < 0 then
    Abort('SansSerif');
  if RegisterBGIfont(@SmallFontProc) < 0 then
    Abort('Small');
  if RegisterBGIfont(@TriplexFontProc) < 0 then
    Abort('Triplex');
end;


procedure initscr(var ok:boolean);
var i,j,k,graphdriver,graphmode,errcode:integer;
    r,g,b                          :word;
begin
   register;
   graphdriver:=detect;
   initgraph(graphdriver,graphmode,'');
   ok:=(graphresult=0) and (graphdriver=9);
      SetRGBPalette(0,0,0,16);
      SetRGBPalette(1,63,63,58);
      SetRGBPalette(2,28,25,28);
      SetRGBPalette(3,52,50,48);
      SetRGBPalette(4,32,13,0);
      SetRGBPalette(5,38,20,10);
      SetRGBPalette(6,48,23,29);
      SetRGBPalette(7,54,29,38);
      SetRGBPalette(8,58,38,48);
      SetRGBPalette(9,63,48,61);
      SetRGBPalette(10,23,23,32);
      SetRGBPalette(11,25,25,38);
      SetRGBPalette(12,29,29,45);
      SetRGBPalette(13,32,35,52);
      SetRGBPalette(14,35,42,58);
      SetRGBPalette(15,38,52,63);
    for i:=0 to 15 do setpalette(i,i);
end;


procedure initimages;
const hex='0123456789ABCDEF ';
var t        :array[0..12] of string;
    i,j,k,c  :integer;
    size     :longint;
    bufptr   :integer;

   procedure getthem(var ima:image; var size:longint);
   var i,j,k,c:integer;
       temp   :string;
   begin
   with ima do begin
      k:=24;
      for i:=1 to 12 do begin
         temp:=t[i];
         for j:=1 to length(temp) do begin
            c:=pred(pos(temp[j],hex));
            putpixel(23+j,k,c);
            putpixel(48-j,k,c);
            putpixel(23+j,71-k,c);
            putpixel(48-j,71-k,c);
         end;
         inc(k);
      end;

      p_data:=addr(ibuff[bufptr]);
      p_nextimage:=nil;
      x:=0;
      y:=0;
      GetImage(24,24,width+23,height+23,p_data^);
      size:=ImageSize(24,24,width+23,height+23);
   end;
   end;


begin
bufptr:=0;
with ima[2] do begin
   width:=24;
   height:=24;
   t[1]:='000000000000';
   t[2]:='000044444444';
   t[3]:='000045555555';
   t[4]:='000045666666';
   t[5]:='044445677777';
   t[6]:='045555678888';
   t[7]:='045666678999';
   t[8]:='045677778911';
   t[9]:='04567888891F';
  t[10]:='0456789991F9';
  t[11]:='045678911F99';
  t[12]:='04567891F999';
end;
getthem(ima[2],size);

bufptr:=bufptr+size;
with ima[1] do begin
   width:=24;
   height:=24;
   height:=24;
   t[1]:='000000000000';
   t[2]:='0000AAAAAAAA';
   t[3]:='0000ABBBBBBB';
   t[4]:='0000ABCCCCCC';
   t[5]:='0AAAABCDDDDD';
   t[6]:='0ABBBBCDEEEE';
   t[7]:='0ABCCCCDEFFF';
   t[8]:='0ABCDDDDEF99';
   t[9]:='0ABCDEEEEF93';
  t[10]:='0ABCDEFFF93F';
  t[11]:='0ABCDEF993FF';
  t[12]:='0ABCDEF93FFF';

end;
getthem(ima[1],size);

bufptr:=bufptr+size;
with ima[3] do begin
   width:=24;
   height:=24;
   t[1]:='AAAAAAAAAAAA';
   t[2]:='AAAAAAAAAAAA';
   t[3]:='AA3333333333';
   t[4]:='AA3331111111';
   t[5]:='AA3331911111';
   t[6]:='AA3331991111';
   t[7]:='AA33319F1111';
   t[8]:='AA3331991111';
   t[9]:='AA33319F1111';
  t[10]:='AA3331991111';
  t[11]:='AA33319F1111';
  t[12]:='AA3331991111';
end;
getthem(ima[3],size);

end;



procedure ladelevel(var l,x,y:integer; var lnamen:string);
var i,j:integer;
    d  :text;
    t,t1:string;
begin

   for i:=0 to xmax do for j:=0 to ymax do f[i,j]:=0;
   for i:=1 to pred(xmax) do if (i mod 4)=0 then begin
      f[i,1]:=1;
      f[i,pred(ymax)]:=1;
   end;
   for i:=0 to pred(xmax div 2) do for j:=1 to pred(ymax) do f[i*2+1,j]:=1;
   lnamen:='Easy does it!';

   str(l:3,t);
   for i:=1 to 3 do if t[i]=#32 then t[i]:='0';
   t:='streamsl.'+t;
{$i-}
   assign(d,t);
   reset(d);
   if ioresult=0 then begin
      readln(d,lnamen);
      for i:=0 to ymax do begin
         readln(d,t1);
         for j:=1 to length(t1) do if t1[j]='1' then f[j-1,i]:=1 else f[j-1,i]:=0;
      end;
      close(d);
   end else l:=0;
{$i+}
   for i:=0 to xmax do for j:=0 to ymax do if f[i,j]>0 then begin
      x:=i; y:=j;
   end;
end;



procedure zeichnescreen;
begin
   rectfill (0,0,639,479,2);
   { Header: --- }
   rectfill(6,8,637,31,0);
   rectfill(2,4,633,27,3);
   setcolor(1); line(3,5,631,5);   line(3,5,3,26);
   setcolor(0); line(3,26,632,26); line(632,5,632,26);
   outtextxy(120,12,'U J A s    S T R E A M S                   TP6 V1.00 5/94');
   { Footer: --- }
   rectfill(6,454,637,477,0);
   rectfill(2,450,633,473,3);
   setcolor(1); line(3,451,631,451);   line(3,451,3,472);
   setcolor(0); line(3,472,632,472); line(632,451,632,472);
   outtextxy(120,458,'S t a t u s z e i l e');
end;


procedure showlevel(l:integer; lnamen:string);
var t:string;
begin
   rectfill(20,458,399,470,3);
   str(l:3,t);
   t:='Level:'+t+'   - '+lnamen+'   -';
   setcolor(0);
   outtextxy(20,458,t);
end;

procedure showpunkte(l:longint);
var t:string;
begin
   rectfill(420,458,559,470,3);
   str(l:7,t);
   t:='Punkte: '+t+'   -';
   setcolor(0);
   outtextxy(420,458,t);
end;


function updatzeit(ho,mo,so,po:word):integer;
var h,m,s,p:word;
    temp   :string;
    sec    :integer;
begin
gettime(h,m,s,p);
p:=p-po; if p<0 then begin dec(s); p:=p+100; end;
s:=s-so; if s<0 then begin dec(m); s:=s+60; end;
m:=m-mo; if m<0 then begin dec(h); m:=m+60; end;
h:=h-ho;
sec:=60*(h*60+m)+s;
str(sec:4,temp);
rectfill(580,458,612,468,3);
setcolor(0);
outtextxy(580,458,temp);
updatzeit:=sec;
end;


procedure movepoint(var x,y:integer; ri:integer);
begin
   p_hilf:=addr(ima[f[x,y]]);
   drawimage(x*dx+ox,y*dy+oy,p_hilf);
   case ri of
   0: if y>1 then if f[x,y-1]>0 then y:=y-1;
   1: if x<pred(xmax) then if f[x+1,y]>0 then x:=x+1;
   2: if y<pred(ymax) then if f[x,y+1]>0 then y:=y+1;
   3: if x>1 then if f[x-1,y]>0 then x:=x-1;
   end;
   p_hilf:=addr(ima[3]);
   drawimage(x*dx+ox,y*dy+oy,p_hilf);
end;



procedure feldrefresh(x,y:integer);
var i,j:integer;
begin
for i:=0 to xmax do for j:=0 to ymax do case f[i,j] of
0: rectfill(i*dx+ox,j*dy+oy,i*dx+ox+pred(dx),j*dy+oy+pred(dy),0);
1: begin p_hilf:=addr(ima[1]); drawimage(i*dx+ox,j*dy+oy,p_hilf) end;
2: begin p_hilf:=addr(ima[2]); drawimage(i*dx+ox,j*dy+oy,p_hilf) end;
end;
p_hilf:=addr(ima[3]); drawimage(x*dx+ox,y*dy+oy,p_hilf);
end;

procedure blaeuen(x,y:integer);
var i,j:integer;
begin
for i:=0 to xmax do for j:=0 to ymax do if f[i,j]>0 then f[i,j]:=1;
end;

function allesrot:boolean;
var i,j:integer; flag:boolean;
begin
flag:=true;
for i:=0 to xmax do for j:=0 to ymax do if f[i,j]=1 then flag:=false;
allesrot:=flag;
end;


procedure faerbe;
begin
f[x,y]:=2;
   dec(y); if y>-1 then if f[x,y]=1 then faerbe;
   y:=y+2; if y<succ(ymax) then if f[x,y]=1 then faerbe;
   dec(y);
   dec(x); if x>-1 then if f[x,y]=1 then faerbe;
   x:=x+2; if x<succ(xmax) then if f[x,y]=1 then faerbe;
   dec(x);
end;



procedure drehen(x,y:integer);
var flag:byte;  i,j:integer;
begin
if f[x,pred(y)]>0 then flag:=1 else flag:=0;
if f[x,succ(y)]>0 then flag:=flag+4;
if f[pred(x),y]>0 then flag:=flag+8;
if f[succ(x),y]>0 then flag:=flag+2;
if (flag and 1)>0 then f[succ(x),y]:=1 else f[succ(x),y]:=0;
if (flag and 2)>0 then f[x,succ(y)]:=1 else f[x,succ(y)]:=0;
if (flag and 4)>0 then f[pred(x),y]:=1 else f[pred(x),y]:=0;
if (flag and 8)>0 then f[x,pred(y)]:=1 else f[x,pred(y)]:=0;
for i:=pred(x) to succ(x) do for j:=pred(y) to succ(y) do if f[i,j]=0 then
rectfill(i*dx+ox,j*dy+oy,i*dx+ox+pred(dx),j*dx+oy+pred(dy),0) else begin
   p_hilf:=addr(ima[1]);
   drawimage(i*dx+ox,j*dy+oy,p_hilf);
end;
p_hilf:=addr(ima[3]);
drawimage(x*dx+ox,y*dy+oy,p_hilf);
end;


procedure fanfare(var ende:boolean);
var i,j,k,l:integer; ch:char;
begin
delay(1000);
for k:=1 to 500 do begin
   l:=succ(random(1000) mod 6);
   if l<3 then if odd(l) then l:=1 else l:=2 else l:=3;
   p_hilf:=addr(ima[l]);
   i:=ox+random(xmax*dx);
   j:=oy+random(ymax*dy);
   drawimage(i,j,p_hilf);
end;
repeat until keypressed;
ch:=readkey;
ende:=ch=#27;
end;

procedure fanfare2(var ende:boolean);
var i,j,k,l:integer; ch:char; t:string;
begin
delay(1000);
rectfill(ox+dx,oy+dy,pred(ox+xmax*dx),pred(oy+ymax*dy),10);
t:='G a m e   o v e r !';
for i:=0 to 99 do begin
   setcolor(4+i mod 11);
   outtextxy(4*dx+ox+2*i,10*dy+oy-i,t);
   delay(5);
end;
i:=100;
setcolor(0);
outtextxy(4*dx+ox+2*i,10*dy+oy-i,t);
i:=101;
setcolor(1);
outtextxy(4*dx+ox+2*i,10*dy+oy-i,t);
repeat delay(50) until keypressed;
ch:=readkey;
ende:=ch=#27;
end;


procedure auswerten(var x,y:integer);
var ri:integer; ch1:char;
begin
   while keypressed do begin
      ch1:=readkey;
      if ch1=#0 then begin
         ch1:=readkey;
         case ch1 of
         #72: ri:=0;
         #75: ri:=3;
         #77: ri:=1;
         #80: ri:=2;
         else;
         end;
         movepoint(x,y,ri);
      end else begin
         ch1:=upcase(ch1);
         case ch1 of
         #27: ende:=true;
         #32: begin
                 drehen(x,y);
                 blaeuen(x,y);
                 faerbe;
                 feldrefresh(x,y);
              end;
         '-': if l>0 then begin
                 dec(l);
                 ladelevel(l,x,y,lnamen);
                 showlevel(l,lnamen);
                 blaeuen(x,y);
                 fo:=f; xo:=x; yo:=y;
                 feldrefresh(x,y);
              end;

         '+': begin
                 inc(l);
                 ladelevel(l,x,y,lnamen);
                 showlevel(l,lnamen);
                 blaeuen(x,y);
                 fo:=f; xo:=x; yo:=y;
                 feldrefresh(x,y);
              end;
         'N': begin
                 f:=fo; x:=xo; y:=yo;
                 feldrefresh(x,y);
              end;

      else ;
      end;
   end;
  end;
end;

{$i strhsc.inc }

begin
   initscr(ok);
   if ok then begin
      initimages;
      zeichnescreen;
      loadhiscore;
      updathiscore(0,0);
      l:=-1;
      punkte:=0;
      ti:=0;
      showpunkte(punkte);
      while not ende do begin
         inc(l);
         ladelevel(l,x,y,lnamen);
         showlevel(l,lnamen);
         blaeuen(x,y);
         fo:=f; xo:=x; yo:=y;
         feldrefresh(x,y);
         gettime(h,m,s,hd);
         count:=0;
         while not (ende or allesrot) and (ti<300) do begin
            auswerten(x,y);
            count:=succ(count) mod 900;
            if count=0 then ti:=updatzeit(h,m,s,hd);         
         end;
         if allesrot then begin
            ti:=500-ti;
            punkte:=punkte+succ(l)*ti;
            showpunkte(punkte);
            fanfare(ende);
            ti:=0;
         end else if (ti>=300) or ende then begin
            fanfare2(ende);
            showpunkte(punkte);
            if not ende then updathiscore(punkte,pred(l));
            l:=-1;
            punkte:=0;
            ti:=0;
         end;
      end;
      textmode(3);
   end;
end.

